<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: CollisionVisitor Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classCollisionVisitor-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CollisionVisitor Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract class of double dispatch visitor design patter.  
 <a href="classCollisionVisitor.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="CollisionVisitor_8h_source.html">CollisionVisitor.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for CollisionVisitor:</div>
<div class="dyncontent">
<div class="center"><img src="classCollisionVisitor__inherit__graph.png" border="0" usemap="#CollisionVisitor_inherit__map" alt="Inheritance graph"/></div>
<map name="CollisionVisitor_inherit__map" id="CollisionVisitor_inherit__map">
<area shape="rect" title="Abstract class of double dispatch visitor design patter." alt="" coords="222,5,342,32"/>
<area shape="rect" href="classCollisionBonus.html" title="Resolves collision between Bonus and other objects." alt="" coords="5,80,124,107"/>
<area shape="rect" href="classCollisionEnemy.html" title="Resolves collision between Enemy and other objects." alt="" coords="149,80,271,107"/>
<area shape="rect" href="classCollisionPlayer.html" title="Resolves collision between Player and other objects." alt="" coords="296,80,415,107"/>
<area shape="rect" href="classCollisionProjectile.html" title="Resolves collision between Projectile and other objects." alt="" coords="439,80,578,107"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af05d93df91ad1b3b7fbf939cbb8f2c28"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionVisitor.html#af05d93df91ad1b3b7fbf939cbb8f2c28">VisitEnemy</a> (<a class="el" href="classEnemy.html">Enemy</a> *enemy)=0</td></tr>
<tr class="memdesc:af05d93df91ad1b3b7fbf939cbb8f2c28"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.">Enemy</a> pointer from visiting object.  <a href="classCollisionVisitor.html#af05d93df91ad1b3b7fbf939cbb8f2c28">More...</a><br /></td></tr>
<tr class="separator:af05d93df91ad1b3b7fbf939cbb8f2c28"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0fb0fccfcfe6bf348588a406b3e26407"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionVisitor.html#a0fb0fccfcfe6bf348588a406b3e26407">VisitProjectile</a> (<a class="el" href="classProjectile.html">Projectile</a> *projectile)=0</td></tr>
<tr class="memdesc:a0fb0fccfcfe6bf348588a406b3e26407"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> pointer from visiting object.  <a href="classCollisionVisitor.html#a0fb0fccfcfe6bf348588a406b3e26407">More...</a><br /></td></tr>
<tr class="separator:a0fb0fccfcfe6bf348588a406b3e26407"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27165ce473133803b0cf2e7343686876"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionVisitor.html#a27165ce473133803b0cf2e7343686876">VisitPlayer</a> (<a class="el" href="classPlayer.html">Player</a> *player)=0</td></tr>
<tr class="memdesc:a27165ce473133803b0cf2e7343686876"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> pointer from visiting object.  <a href="classCollisionVisitor.html#a27165ce473133803b0cf2e7343686876">More...</a><br /></td></tr>
<tr class="separator:a27165ce473133803b0cf2e7343686876"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac21e99081aed7153372f3aa3b72e7cf5"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionVisitor.html#ac21e99081aed7153372f3aa3b72e7cf5">VisitBonus</a> (<a class="el" href="classBonus.html">Bonus</a> *bonus)=0</td></tr>
<tr class="memdesc:ac21e99081aed7153372f3aa3b72e7cf5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer from visiting object.  <a href="classCollisionVisitor.html#ac21e99081aed7153372f3aa3b72e7cf5">More...</a><br /></td></tr>
<tr class="separator:ac21e99081aed7153372f3aa3b72e7cf5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract class of double dispatch visitor design patter. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="ac21e99081aed7153372f3aa3b72e7cf5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac21e99081aed7153372f3aa3b72e7cf5">&#9670;&nbsp;</a></span>VisitBonus()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void CollisionVisitor::VisitBonus </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classBonus.html">Bonus</a> *&#160;</td>
          <td class="paramname"><em>bonus</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer from visiting object. </p>

<p>Implemented in <a class="el" href="classCollisionProjectile.html#a8ae39a9c7b38ab8d4e0965f80bda128d">CollisionProjectile</a>, <a class="el" href="classCollisionBonus.html#a3deb7dbb790606457edd73a4443d1001">CollisionBonus</a>, <a class="el" href="classCollisionEnemy.html#a47e1ae390eb0ad1724e2f2c9ef22f850">CollisionEnemy</a>, and <a class="el" href="classCollisionPlayer.html#a70532d8dd3460944d7c09294337333a5">CollisionPlayer</a>.</p>

</div>
</div>
<a id="af05d93df91ad1b3b7fbf939cbb8f2c28"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af05d93df91ad1b3b7fbf939cbb8f2c28">&#9670;&nbsp;</a></span>VisitEnemy()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void CollisionVisitor::VisitEnemy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEnemy.html">Enemy</a> *&#160;</td>
          <td class="paramname"><em>enemy</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.">Enemy</a> pointer from visiting object. </p>

<p>Implemented in <a class="el" href="classCollisionProjectile.html#ac5a5da223a772354ef805e2f01be36f4">CollisionProjectile</a>, <a class="el" href="classCollisionBonus.html#aff73cb5263fadec07b617171936ce3f2">CollisionBonus</a>, <a class="el" href="classCollisionEnemy.html#ad8f7122e1d2ecc35b1314a6b8914086a">CollisionEnemy</a>, and <a class="el" href="classCollisionPlayer.html#a6c7b72ba0659a5af4ea831f467303e45">CollisionPlayer</a>.</p>

</div>
</div>
<a id="a27165ce473133803b0cf2e7343686876"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27165ce473133803b0cf2e7343686876">&#9670;&nbsp;</a></span>VisitPlayer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void CollisionVisitor::VisitPlayer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classPlayer.html">Player</a> *&#160;</td>
          <td class="paramname"><em>player</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> pointer from visiting object. </p>

<p>Implemented in <a class="el" href="classCollisionProjectile.html#aed4abf7c92949c10b44799bf540e5416">CollisionProjectile</a>, <a class="el" href="classCollisionBonus.html#a465bb52368516d6ebf0db27aa1096f1b">CollisionBonus</a>, <a class="el" href="classCollisionEnemy.html#a69f0406eb5baf03d312a34b7ca810954">CollisionEnemy</a>, and <a class="el" href="classCollisionPlayer.html#ae8bc585e6957a6d630394bf1dedb9ac7">CollisionPlayer</a>.</p>

</div>
</div>
<a id="a0fb0fccfcfe6bf348588a406b3e26407"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0fb0fccfcfe6bf348588a406b3e26407">&#9670;&nbsp;</a></span>VisitProjectile()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void CollisionVisitor::VisitProjectile </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classProjectile.html">Projectile</a> *&#160;</td>
          <td class="paramname"><em>projectile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> pointer from visiting object. </p>

<p>Implemented in <a class="el" href="classCollisionProjectile.html#a3ecf64b1d68b549f1a478f55f6e84c54">CollisionProjectile</a>, <a class="el" href="classCollisionBonus.html#aea3256a97e9b80d02a0c1234d47694e1">CollisionBonus</a>, <a class="el" href="classCollisionEnemy.html#ae88d05c50d4cdb6e408d399b6bfa33ec">CollisionEnemy</a>, and <a class="el" href="classCollisionPlayer.html#a83723cb8c1478311edfb8ae22bdbe049">CollisionPlayer</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="CollisionVisitor_8h_source.html">CollisionVisitor.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
